-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4506 of the CMF schema. Adds the command schedules table.
--

update SCHEMA_VERSION set VERSION=4506;

create table COMMAND_SCHEDULES (
  SPEC_ID int8 not null,
  COMMAND_NAME varchar(255) not null,
  COMMAND_ARGUMENTS varchar(1048576),
  CLUSTER_ID int8,
  SERVICE_ID int8,
  ROLE_ID int8,
  HOST_ID int8,
  START_TIME int8,
  END_TIME int8,
  REPEAT_INTERVAL int8 not null,
  REPEAT_INTERVAL_UNIT varchar(255) not null,
  PAUSED bool not null,
  OPTIMISTIC_LOCK_VERSION int8 not null,
  primary key (SPEC_ID)
);

create index IDX_COMMAND_SCHEDULE_CLUSTER on COMMAND_SCHEDULES (CLUSTER_ID);

create index IDX_COMMAND_SCHEDULE_SERVICE on COMMAND_SCHEDULES (SERVICE_ID);

create index IDX_COMMAND_SCHEDULE_ROLE on COMMAND_SCHEDULES (ROLE_ID);

create index IDX_COMMAND_SCHEDULE_HOST on COMMAND_SCHEDULES (HOST_ID);

alter table COMMAND_SCHEDULES
  add constraint FK_COMMAND_SCHEDULE_CLUSTER
  foreign key (CLUSTER_ID)
  references CLUSTERS;

alter table COMMAND_SCHEDULES
  add constraint FK_COMMAND_SCHEDULE_SERVICE
  foreign key (SERVICE_ID)
  references SERVICES;

alter table COMMAND_SCHEDULES
  add constraint FK_COMMAND_SCHEDULE_ROLE
  foreign key (ROLE_ID)
  references ROLES;

alter table COMMAND_SCHEDULES
  add constraint FK_COMMAND_SCHEDULE_HOST
  foreign key (HOST_ID)
  references HOSTS;
